% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mpl_morphyex.R
\name{mpl_translate_error}
\alias{mpl_translate_error}
\title{Converts a numeric error code to human-readable format}
\usage{
mpl_translate_error(errorCode)
}
\arguments{
\item{errorCode}{Non-positive integer to be converted}
}
\value{
A character string corresponding to the provided error code
}
\description{
Converts a numeric error code to human-readable format
}
\examples{
mpl_translate_error(-1) # "ERR_INVALID_SYMBOL"

}
\seealso{
Other Morphy API functions: \code{\link{MorphyErrorCheck}},
  \code{\link{MorphyWeights}}, \code{\link{PhyDat2Morphy}},
  \code{\link{SetMorphyWeights}},
  \code{\link{SingleCharMorphy}},
  \code{\link{UnloadMorphy}},
  \code{\link{mpl_apply_tipdata}},
  \code{\link{mpl_attach_rawdata}},
  \code{\link{mpl_attach_symbols}},
  \code{\link{mpl_delete_Morphy}},
  \code{\link{mpl_delete_rawdata}},
  \code{\link{mpl_first_down_recon}},
  \code{\link{mpl_first_up_recon}},
  \code{\link{mpl_get_charac_weight}},
  \code{\link{mpl_get_num_charac}},
  \code{\link{mpl_get_num_internal_nodes}},
  \code{\link{mpl_get_numtaxa}},
  \code{\link{mpl_get_symbols}},
  \code{\link{mpl_init_Morphy}},
  \code{\link{mpl_new_Morphy}},
  \code{\link{mpl_second_down_recon}},
  \code{\link{mpl_second_up_recon}},
  \code{\link{mpl_set_charac_weight}},
  \code{\link{mpl_set_num_internal_nodes}},
  \code{\link{mpl_set_parsim_t}},
  \code{\link{mpl_update_lower_root}},
  \code{\link{mpl_update_tip}},
  \code{\link{summary.morphyPtr}}
}
\author{
Martin R. Smith
}
\concept{Morphy API functions}
\keyword{internal}
